// C++ interface wrapper code.
//
// Generated by SIP 3.10.1 (3.10.1-192) on Fri Mar 12 18:04:10 2004
//
// Copyright (c) 2004
// 	Riverbank Computing Limited <info@riverbankcomputing.co.uk>
// 
// This file is part of PyQt.
// 
// This copy of PyQt is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2, or (at your option) any later
// version.
// 
// PyQt is supplied in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
// 
// You should have received a copy of the GNU General Public License along with
// PyQt; see the file LICENSE.  If not, write to the Free Software Foundation,
// Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include "sipqtDeclqt.h"
#include "sipqtQPointArray.h"


PyObject *sipClass_QPointArray;

static void sipDealloc_QPointArray(sipThisType *);

static PyTypeObject sipType_QPointArray = {
	PyObject_HEAD_INIT(&PyType_Type)
	0,
	sipWrapperTypeName,
	sizeof (sipThisType),
	0,
	(destructor)sipDealloc_QPointArray,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	Py_TPFLAGS_DEFAULT,
};
#line 97 "sip/qt/qpointarray.sip"
// Convert a list of numbers to an array on QCOORDs on the heap.

static QCOORD *getPoints(int nrpnts,PyObject *pntlist)
{
	QCOORD *pnts, *pp;

	if ((pnts = (QCOORD *)sipMalloc(nrpnts * sizeof (QCOORD))) == NULL)
		return NULL;

	// Convert the list.

	pp = pnts;

	for (int i = 0; i < nrpnts; ++i)
	{
		*pp++ = (QCOORD)PyInt_AsLong(PyList_GetItem(pntlist,i));

		if (PyErr_Occurred() != NULL)
		{
			sipFree((ANY *)pnts);
			return NULL;
		}
	}

	return pnts;
}
#line 83 "sipqtQPointArray.cpp"

static PyObject *sipDo_QPointArray_copy(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"m",sipThisObj,sipClass_QPointArray,&sipCpp))
		{
			QPointArray *sipRes;

			Py_BEGIN_ALLOW_THREADS
			sipRes = new QPointArray(sipCpp -> QPointArray::copy());
			Py_END_ALLOW_THREADS

			return sipNewCppToSelf(sipRes,sipClass_QPointArray,SIP_SIMPLE|SIP_PY_OWNED);
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_copy);

	return NULL;
}

static PyObject *sipDo_QPointArray_translate(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		int a0;
		int a1;
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"mii",sipThisObj,sipClass_QPointArray,&sipCpp,&a0,&a1))
		{
			Py_BEGIN_ALLOW_THREADS
			sipCpp -> QPointArray::translate(a0,a1);
			Py_END_ALLOW_THREADS

			Py_INCREF(Py_None);
			return Py_None;
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_translate);

	return NULL;
}

static PyObject *sipDo_QPointArray_boundingRect(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"m",sipThisObj,sipClass_QPointArray,&sipCpp))
		{
			QRect *sipRes;

			Py_BEGIN_ALLOW_THREADS
			sipRes = new QRect(sipCpp -> QPointArray::boundingRect());
			Py_END_ALLOW_THREADS

			return sipNewCppToSelf(sipRes,sipClass_QRect,SIP_SIMPLE|SIP_PY_OWNED);
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_boundingRect);

	return NULL;
}

static PyObject *sipDo_QPointArray_point(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		unsigned a0;
		int a1;
		int a2;
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"mi",sipThisObj,sipClass_QPointArray,&sipCpp,&a0))
		{
			Py_BEGIN_ALLOW_THREADS
			sipCpp -> QPointArray::point(a0,&a1,&a2);
			Py_END_ALLOW_THREADS

			return sipBuildResult(0,"(ii)",a1,a2);
		}
	}

	{
		unsigned a0;
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"mi",sipThisObj,sipClass_QPointArray,&sipCpp,&a0))
		{
			QPoint *sipRes;

			Py_BEGIN_ALLOW_THREADS
			sipRes = new QPoint(sipCpp -> QPointArray::point(a0));
			Py_END_ALLOW_THREADS

			return sipNewCppToSelf(sipRes,sipClass_QPoint,SIP_SIMPLE|SIP_PY_OWNED);
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_point);

	return NULL;
}

static PyObject *sipDo_QPointArray_setPoint(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		unsigned a0;
		int a1;
		int a2;
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"miii",sipThisObj,sipClass_QPointArray,&sipCpp,&a0,&a1,&a2))
		{
			Py_BEGIN_ALLOW_THREADS
			sipCpp -> QPointArray::setPoint(a0,a1,a2);
			Py_END_ALLOW_THREADS

			Py_INCREF(Py_None);
			return Py_None;
		}
	}

	{
		unsigned a0;
		QPoint * a1;
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"miJ1",sipThisObj,sipClass_QPointArray,&sipCpp,&a0,sipClass_QPoint,&a1))
		{
			Py_BEGIN_ALLOW_THREADS
			sipCpp -> QPointArray::setPoint(a0,*a1);
			Py_END_ALLOW_THREADS

			Py_INCREF(Py_None);
			return Py_None;
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_setPoint);

	return NULL;
}

static PyObject *sipDo_QPointArray_setPoints(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		PyObject * a0;
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"mT",sipThisObj,sipClass_QPointArray,&sipCpp,&PyList_Type,&a0))
		{
			bool sipRes;
			int sipIsErr = FALSE;

#line 165 "sip/qt/qpointarray.sip"
		int nrpnts;
		QCOORD *pnts;

		nrpnts = PyList_GET_SIZE(a0);

		if ((pnts = getPoints(nrpnts,a0)) == NULL)
			sipIsErr = 1;
		else
		{
			Py_BEGIN_ALLOW_THREADS
			sipRes = sipCpp -> setPoints(nrpnts / 2,pnts);
			Py_END_ALLOW_THREADS

			sipFree((ANY *)pnts);
		}
#line 280 "sipqtQPointArray.cpp"

			if (sipIsErr)
                               return NULL;

			return sipConvertFromBool((int)sipRes);
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_setPoints);

	return NULL;
}

static PyObject *sipDo_QPointArray_putPoints(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		int a0;
		PyObject * a1;
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"miT",sipThisObj,sipClass_QPointArray,&sipCpp,&a0,&PyList_Type,&a1))
		{
			bool sipRes;
			int sipIsErr = FALSE;

#line 186 "sip/qt/qpointarray.sip"
		int nrpnts;
		QCOORD *pnts;

		nrpnts = PyList_GET_SIZE(a1);

		if ((pnts = getPoints(nrpnts,a1)) == NULL)
			sipIsErr = 1;
		else
		{
			Py_BEGIN_ALLOW_THREADS
			sipRes = sipCpp -> putPoints(a0,nrpnts / 2,pnts);
			Py_END_ALLOW_THREADS

			sipFree((ANY *)pnts);
		}
#line 326 "sipqtQPointArray.cpp"

			if (sipIsErr)
                               return NULL;

			return sipConvertFromBool((int)sipRes);
		}
	}

	{
		int a0;
		int a1;
		QPointArray * a2;
		int a3 = 0;
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"miiJ1|i",sipThisObj,sipClass_QPointArray,&sipCpp,&a0,&a1,sipClass_QPointArray,&a2,&a3))
		{
			bool sipRes;

			Py_BEGIN_ALLOW_THREADS
			sipRes = sipCpp -> QPointArray::putPoints(a0,a1,*a2,a3);
			Py_END_ALLOW_THREADS

			return sipConvertFromBool((int)sipRes);
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_putPoints);

	return NULL;
}

static PyObject *sipDo_QPointArray_makeArc(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		int a0;
		int a1;
		int a2;
		int a3;
		int a4;
		int a5;
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"miiiiii",sipThisObj,sipClass_QPointArray,&sipCpp,&a0,&a1,&a2,&a3,&a4,&a5))
		{
			Py_BEGIN_ALLOW_THREADS
			sipCpp -> QPointArray::makeArc(a0,a1,a2,a3,a4,a5);
			Py_END_ALLOW_THREADS

			Py_INCREF(Py_None);
			return Py_None;
		}
	}

	{
		int a0;
		int a1;
		int a2;
		int a3;
		int a4;
		int a5;
		QWMatrix * a6;
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"miiiiiiJ1",sipThisObj,sipClass_QPointArray,&sipCpp,&a0,&a1,&a2,&a3,&a4,&a5,sipClass_QWMatrix,&a6))
		{
			Py_BEGIN_ALLOW_THREADS
			sipCpp -> QPointArray::makeArc(a0,a1,a2,a3,a4,a5,*a6);
			Py_END_ALLOW_THREADS

			Py_INCREF(Py_None);
			return Py_None;
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_makeArc);

	return NULL;
}

static PyObject *sipDo_QPointArray_makeEllipse(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		int a0;
		int a1;
		int a2;
		int a3;
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"miiii",sipThisObj,sipClass_QPointArray,&sipCpp,&a0,&a1,&a2,&a3))
		{
			Py_BEGIN_ALLOW_THREADS
			sipCpp -> QPointArray::makeEllipse(a0,a1,a2,a3);
			Py_END_ALLOW_THREADS

			Py_INCREF(Py_None);
			return Py_None;
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_makeEllipse);

	return NULL;
}

static PyObject *sipDo_QPointArray_cubicBezier(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"m",sipThisObj,sipClass_QPointArray,&sipCpp))
		{
			QPointArray *sipRes;

			Py_BEGIN_ALLOW_THREADS
			sipRes = new QPointArray(sipCpp -> QPointArray::cubicBezier());
			Py_END_ALLOW_THREADS

			return sipNewCppToSelf(sipRes,sipClass_QPointArray,SIP_SIMPLE|SIP_PY_OWNED);
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_cubicBezier);

	return NULL;
}

static PyObject *sipDo_QPointArray_nrefs(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"m",sipThisObj,sipClass_QPointArray,&sipCpp))
		{
			unsigned sipRes;

			Py_BEGIN_ALLOW_THREADS
			sipRes = sipCpp -> QPointArray::nrefs();
			Py_END_ALLOW_THREADS

			return PyInt_FromLong((long)sipRes);
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_nrefs);

	return NULL;
}

static PyObject *sipDo_QPointArray_isEmpty(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"m",sipThisObj,sipClass_QPointArray,&sipCpp))
		{
			bool sipRes;

			Py_BEGIN_ALLOW_THREADS
			sipRes = sipCpp -> QPointArray::isEmpty();
			Py_END_ALLOW_THREADS

			return sipConvertFromBool((int)sipRes);
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_isEmpty);

	return NULL;
}

static PyObject *sipDo_QPointArray_isNull(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"m",sipThisObj,sipClass_QPointArray,&sipCpp))
		{
			bool sipRes;

			Py_BEGIN_ALLOW_THREADS
			sipRes = sipCpp -> QPointArray::isNull();
			Py_END_ALLOW_THREADS

			return sipConvertFromBool((int)sipRes);
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_isNull);

	return NULL;
}

static PyObject *sipDo_QPointArray_resize(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		unsigned a0;
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"mi",sipThisObj,sipClass_QPointArray,&sipCpp,&a0))
		{
			bool sipRes;

			Py_BEGIN_ALLOW_THREADS
			sipRes = sipCpp -> QPointArray::resize(a0);
			Py_END_ALLOW_THREADS

			return sipConvertFromBool((int)sipRes);
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_resize);

	return NULL;
}

static PyObject *sipDo_QPointArray_size(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"m",sipThisObj,sipClass_QPointArray,&sipCpp))
		{
			unsigned sipRes;

			Py_BEGIN_ALLOW_THREADS
			sipRes = sipCpp -> QPointArray::size();
			Py_END_ALLOW_THREADS

			return PyInt_FromLong((long)sipRes);
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_size);

	return NULL;
}

static PyObject *sipDo_QPointArray_truncate(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		unsigned a0;
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"mi",sipThisObj,sipClass_QPointArray,&sipCpp,&a0))
		{
			bool sipRes;

			Py_BEGIN_ALLOW_THREADS
			sipRes = sipCpp -> QPointArray::truncate(a0);
			Py_END_ALLOW_THREADS

			return sipConvertFromBool((int)sipRes);
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_truncate);

	return NULL;
}

static PyObject *sipDo_QPointArray_fill(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		QPoint * a0;
		int a1 = -1;
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"mJ1|i",sipThisObj,sipClass_QPointArray,&sipCpp,sipClass_QPoint,&a0,&a1))
		{
			bool sipRes;

			Py_BEGIN_ALLOW_THREADS
			sipRes = sipCpp -> QPointArray::fill(*a0,a1);
			Py_END_ALLOW_THREADS

			return sipConvertFromBool((int)sipRes);
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_fill);

	return NULL;
}

static PyObject *sipDo_QPointArray_at(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		unsigned a0;
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"mi",sipThisObj,sipClass_QPointArray,&sipCpp,&a0))
		{
			QPoint *sipRes;

			Py_BEGIN_ALLOW_THREADS
			sipRes = &sipCpp -> QPointArray::at(a0);
			Py_END_ALLOW_THREADS

			return sipMapCppToSelf(sipRes,sipClass_QPoint);
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_at);

	return NULL;
}

static PyObject *sipDo_QPointArray_sort(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"m",sipThisObj,sipClass_QPointArray,&sipCpp))
		{
			Py_BEGIN_ALLOW_THREADS
			sipCpp -> QPointArray::sort();
			Py_END_ALLOW_THREADS

			Py_INCREF(Py_None);
			return Py_None;
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_sort);

	return NULL;
}

static PyObject *sipDo_QPointArray_bsearch(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		QPoint * a0;
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"mJ1",sipThisObj,sipClass_QPointArray,&sipCpp,sipClass_QPoint,&a0))
		{
			int sipRes;

			Py_BEGIN_ALLOW_THREADS
			sipRes = sipCpp -> QPointArray::bsearch(*a0);
			Py_END_ALLOW_THREADS

			return PyInt_FromLong((long)sipRes);
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_bsearch);

	return NULL;
}

static PyObject *sipDo_QPointArray_find(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		QPoint * a0;
		unsigned a1 = 0;
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"mJ1|i",sipThisObj,sipClass_QPointArray,&sipCpp,sipClass_QPoint,&a0,&a1))
		{
			int sipRes;

			Py_BEGIN_ALLOW_THREADS
			sipRes = sipCpp -> QPointArray::find(*a0,a1);
			Py_END_ALLOW_THREADS

			return PyInt_FromLong((long)sipRes);
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_find);

	return NULL;
}

static PyObject *sipDo_QPointArray_contains(PyObject *sipThisObj,PyObject *sipArgs)
{
	int sipArgsParsed = 0;

	{
		QPoint * a0;
		QPointArray *sipCpp;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"mJ1",sipThisObj,sipClass_QPointArray,&sipCpp,sipClass_QPoint,&a0))
		{
			int sipRes;

			Py_BEGIN_ALLOW_THREADS
			sipRes = sipCpp -> QPointArray::contains(*a0);
			Py_END_ALLOW_THREADS

			return PyInt_FromLong((long)sipRes);
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_QPointArray,sipName_contains);

	return NULL;
}

// Cast a pointer to a type somewhere in its superclass hierarchy.

const void *sipCast_QPointArray(const void *ptr,PyObject *targetClass)
{
	if (targetClass == sipClass_QPointArray)
		return ptr;

	return NULL;
}

static void sipDealloc_QPointArray(sipThisType *sipThis)
{
	if (sipThis -> u.cppPtr != NULL)
	{

		if (sipIsPyOwned(sipThis))
		{
			Py_BEGIN_ALLOW_THREADS

			delete (QPointArray *)sipThis -> u.cppPtr;

			Py_END_ALLOW_THREADS
		}
	}

	sipDeleteThis(sipThis);
}

PyObject *sipNew_QPointArray(PyObject *sipSelf,PyObject *sipArgs)
{
	static sipExtraType et = {
		sipCast_QPointArray,
		(void *)sipNewProxy_qt,
		NULL
	};

	int sipFlags = SIP_PY_OWNED;
	int sipArgsParsed = 0;
	sipThisType *sipThis = NULL;
	QPointArray *sipCpp = NULL;

	// See if there is something pending.

	sipCpp = (QPointArray *)sipGetPending(&sipFlags);

	if (sipCpp == NULL)
	{
		if (sipParseArgs(&sipArgsParsed,sipArgs,""))
		{
			Py_BEGIN_ALLOW_THREADS
			sipCpp = new QPointArray();
			Py_END_ALLOW_THREADS
		}
	}

	if (sipCpp == NULL)
	{
		int a0;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"i",&a0))
		{
			Py_BEGIN_ALLOW_THREADS
			sipCpp = new QPointArray(a0);
			Py_END_ALLOW_THREADS
		}
	}

	if (sipCpp == NULL)
	{
		QPointArray * a0;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"J1",sipClass_QPointArray,&a0))
		{
			Py_BEGIN_ALLOW_THREADS
			sipCpp = new QPointArray(*a0);
			Py_END_ALLOW_THREADS
		}
	}

	if (sipCpp == NULL)
	{
		QRect * a0;
		bool a1 = 0;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"J1|b",sipClass_QRect,&a0,&a1))
		{
			Py_BEGIN_ALLOW_THREADS
			sipCpp = new QPointArray(*a0,a1);
			Py_END_ALLOW_THREADS
		}
	}

	if (sipCpp == NULL)
	{
		int sipIsErr = FALSE;
		PyObject * a0;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"T",&PyList_Type,&a0))
		{
#line 133 "sip/qt/qpointarray.sip"
		// The Python interface is a list of QCOORDs.

		int nrpnts;
		QCOORD *pnts;

		nrpnts = PyList_GET_SIZE(a0);

		if ((pnts = getPoints(nrpnts,a0)) == NULL)
			sipIsErr = 1;
		else
		{
			// No wrapper class for QPointArray.

			Py_BEGIN_ALLOW_THREADS
			sipCpp = new QPointArray(nrpnts / 2,pnts);
			Py_END_ALLOW_THREADS

			sipFree((ANY *)pnts);
		}
#line 907 "sipqtQPointArray.cpp"

			if (sipIsErr)
				return NULL;
		}
	}

	if (sipCpp == NULL)
	{
		sipNoCtor(sipArgsParsed,sipName_QPointArray);
		return NULL;
	}

	// Wrap the object.

	if ((sipThis = sipCreateThis(sipSelf,sipCpp,&sipType_QPointArray,sipFlags,&et)) == NULL)
	{
		if (sipFlags & SIP_PY_OWNED)
		{
			Py_BEGIN_ALLOW_THREADS

			delete (QPointArray *)sipCpp;

			Py_END_ALLOW_THREADS
		}

		return NULL;
	}

	Py_INCREF(Py_None);
	return Py_None;
}

static PyMethodDef lazyMethods_QPointArray[] = {
	{sipName_at, sipDo_QPointArray_at, METH_VARARGS, NULL},
	{sipName_boundingRect, sipDo_QPointArray_boundingRect, METH_VARARGS, NULL},
	{sipName_bsearch, sipDo_QPointArray_bsearch, METH_VARARGS, NULL},
	{sipName_contains, sipDo_QPointArray_contains, METH_VARARGS, NULL},
	{sipName_copy, sipDo_QPointArray_copy, METH_VARARGS, NULL},
	{sipName_cubicBezier, sipDo_QPointArray_cubicBezier, METH_VARARGS, NULL},
	{sipName_fill, sipDo_QPointArray_fill, METH_VARARGS, NULL},
	{sipName_find, sipDo_QPointArray_find, METH_VARARGS, NULL},
	{sipName_isEmpty, sipDo_QPointArray_isEmpty, METH_VARARGS, NULL},
	{sipName_isNull, sipDo_QPointArray_isNull, METH_VARARGS, NULL},
	{sipName_makeArc, sipDo_QPointArray_makeArc, METH_VARARGS, NULL},
	{sipName_makeEllipse, sipDo_QPointArray_makeEllipse, METH_VARARGS, NULL},
	{sipName_nrefs, sipDo_QPointArray_nrefs, METH_VARARGS, NULL},
	{sipName_point, sipDo_QPointArray_point, METH_VARARGS, NULL},
	{sipName_putPoints, sipDo_QPointArray_putPoints, METH_VARARGS, NULL},
	{sipName_resize, sipDo_QPointArray_resize, METH_VARARGS, NULL},
	{sipName_setPoint, sipDo_QPointArray_setPoint, METH_VARARGS, NULL},
	{sipName_setPoints, sipDo_QPointArray_setPoints, METH_VARARGS, NULL},
	{sipName_size, sipDo_QPointArray_size, METH_VARARGS, NULL},
	{sipName_sort, sipDo_QPointArray_sort, METH_VARARGS, NULL},
	{sipName_translate, sipDo_QPointArray_translate, METH_VARARGS, NULL},
	{sipName_truncate, sipDo_QPointArray_truncate, METH_VARARGS, NULL}
};

sipLazyAttrDef sipClassAttrTab_QPointArray = {
	0, NULL,
	sizeof (lazyMethods_QPointArray) / sizeof (PyMethodDef), lazyMethods_QPointArray,
	0, NULL
};

QPointArray *sipForceConvertTo_QPointArray(PyObject *valobj,int *iserrp)
{
	if (*iserrp || valobj == NULL)
		return NULL;

	if (valobj == Py_None || sipIsSubClassInstance(valobj,sipClass_QPointArray))
		return (QPointArray *)sipConvertToCpp(valobj,sipClass_QPointArray,iserrp);

	sipBadClass(sipName_QPointArray);

	*iserrp = 1;

	return NULL;
}
